;.ESEG 
;.org 0x1fc
;eevar1: .DW 0xEF04	; Systemconfg, Kontrast
;eevar2: .DW 0xFF00	; Beleucht, Init

.CSEG
.equ    P_INT   =PortB
.equ    P_BUSY  =PortB

.equ    P_I2CC  =PortD
.equ    P_I2CD  =PortD
.equ    P_CLR   =PortD
.equ    P_BUS   =PortC

.equ    PIN_DREH=PINB
.equ    PIN_DEM =PIND
.equ    PIN_STR =PIND
.equ    PIN_CTRL=PIND
.equ    PIN_I2CD=PIND
.equ    PIN_BUS =PINC

.equ    DDR_I2CC=DDRD
.equ    DDR_I2CD=DDRD
.equ    DDR_BUS =DDRC



.equ    LCD_RW  =PD6                    ;Bit 6 in Port D
.equ    LCD_ADR =PD7                    ;Bit 6 in Port D
.equ    KONTR   =PD5                    ;Bit 5 in Port D
.equ    I2CC    =PD4                    ;Bit 4 in Port D
.equ    STROBE  =PD3                    ;Bit 3 in Port D
.equ    DEMAND  =PD2                    ;Bit 2 in Port D
.equ    I2CD    =PD1                    ;Bit 1 in Port D
.equ    CLR     =PD0                    ;Bit 0 in Port D

.equ    SCLK    =PB7                    ;Bit 7 in Port B
.equ    SREAD   =PB6                    ;Bit 6 in Port B
.equ    SDATA   =PB5                    ;Bit 5 in Port B
.equ    CTRL2   =PD5                    ;Bit 3 in Port B
.equ    CTRL1   =PD7                    ;Bit 1 in Port B
.equ    CTRL0   =PD6                    ;Bit 0 in Port B

.equ    LCD_SEL2=PA7                    ;Bit 7 in Port A

.equ    LCD_SEL =PB3                    ;Bit 7 in Port B
.equ    BUSY    =PB4                    ;Bit 4 in Port B
.equ    INT     =PB2                    ;Bit 2 in Port B
.equ    DREH0   =PB0                    ;Bit 1 in Port B
.equ    DREH1   =PB1                    ;Bit 0 in Port B


.equ    VERSION =$11



;*********************************************************************
;  Interruptroutine  Get Data and Control
;*********************************************************************
Get_INT_Param:  in      PData,PINC               ; Daten sichern
                in      PCtrl,PIND               ; Ctrl-Informationen sichern
                clt
                sbic    PINB,SREAD
                set
                bld     PCtrl,CTRL2

                andi    PCtrl,(1<<CTRL0)+(1<<CTRL1)+(1<<CTRL2)
                ret


Set_Data:       out     PortC,PData              ; Daten ausgeben
                ret

Output:         ret

Input:          ret



;*********************************************************************
;  Display-Routinen
;*********************************************************************

WriteLCDinit:   cbi     PortD,LCD_ADR
                rjmp    WriteLCD
WriteLCD0:      rcall   BusyCheck
                cbi     PortD,LCD_ADR
                rjmp    WriteLCD
WriteLCD1:      rcall   BusyCheck
                sbi     PortD,LCD_ADR
                rjmp    WriteLCD
WriteLCD:       sbi     DDRD,LCD_ADR
                sbi     DDRD,LCD_RW
                cbi     PortD,LCD_RW
                out     PortC,Temp
                ldi     Temp,$0ff
                out     DDRC,Temp
                rcall   LCD_Strobe                                   ;01
                ldi     Temp,$000
                out     PortC,Temp
                out     DDRC,Temp
                cbi     PortD,LCD_ADR
                cbi     DDRD,LCD_ADR
                cbi     DDRD,LCD_RW
                ret


ReadLCD0:       cbi     PortD,LCD_ADR
                rjmp    ReadLCD
ReadLCD1:       sbi     PortD,LCD_ADR
                rjmp    ReadLCD
ReadLCD:        sbi     DDRD,LCD_ADR
                sbi     DDRD,LCD_RW
                sbi     PortD,LCD_RW
                rcall   LCD_Strobe                                   ;01
                cbi     DDRD,LCD_ADR
                cbi     DDRD,LCD_RW
                ret


BusyCheck:      sbi     DDRD,LCD_ADR
                sbi     DDRD,LCD_RW
                cbi     PortD,LCD_ADR
                sbi     PortD,LCD_RW
                push    Temp
                ldi     Timer,36                 ; 5 ms Timeout      ;01
WaitCheck:      tst     Timer                                        ;01
                breq    GoCheck                                      ;01
                rcall   LCD_Strobe                                   ;01
                sbrc    Temp,7                                       ;01
                rjmp    WaitCheck                                    ;01
GoCheck:        pop     Temp
                cbi     PortD,LCD_RW
                cbi     PortD,LCD_ADR
                cbi     DDRD,LCD_ADR
                cbi     DDRD,LCD_RW
                ret

LCD_Strobe:     sbrs    Status2,DISPLAY                              ;01
                sbi     PortB,LCD_SEL                                ;01
                sbrc    Status2,DISPLAY                              ;01
                sbi     PortA,LCD_SEL2                               ;01
                nop                                                  ;01
                nop                                                  ;01
                nop                                                  ;01
                nop                                                  ;01
                in      Temp,PINC                                    ;01
                sbrs    Status2,DISPLAY                              ;01
                cbi     PortB,LCD_SEL                                ;01
                sbrc    Status2,DISPLAY                              ;01
                cbi     PortA,LCD_SEL2                               ;01
                ret                                                  ;01



;*********************************************************************
;  TastenPort lesen
;*********************************************************************
Tasten_Input:   push    TOVTemp1	    ; Temp1 sichern          ;01
                lds     TOVTemp1,Systemcfg                           ;01
                sbrs    TOVTemp1,TastEnh    		             ;01
                rjmp    Poll_Matrix	    ; Matrix-TT              ;01
                in      TOVTemp,PINA	    ; PortA lesen
                com     TOVTemp		    ; invertieren
                sbrs    TOVTemp1,DisEnh	    ; Displaytype : 40er
                andi    TOVTemp,$7F	    ; Bit7 maskieren         ;01
                pop     TOVTemp1	    ; Temp1 zurckholen      ;01
                ret

Poll_Matrix:    sbrs	TOVTemp1,TastEnh2                            ;01b
                rjmp	Poll_138	    ; extended Matrix-TT     ;01b
		clr     TOVTemp                                      ;01
                sbrs    TOVTemp1,DisEnh	    ; Displaytype : 40er     ;01
                rjmp    Poll_Matrix1                                 ;01
                                                                     ;01
                cbi     PortA,7                                      ;01
                nop                                                  ;01
                in      TOVTemp,PINA                                 ;01
                com     TOVTemp                                      ;01
                andi    TOVTemp,$0F                                  ;01
                breq    Poll_Matrix2                                 ;01
                ori     TOVTemp,$80                                  ;01
Poll_Matrix2:   sbi     PortA,7                                      ;01
Poll_Matrix1:   mov     TOVTemp1,TOVTemp                             ;01

                cbi     PortA,6                                      ;01
                nop                                                  ;01
                in      TOVTemp,PINA                                 ;01
                com     TOVTemp                                      ;01
                andi    TOVTemp,$0F                                  ;01
                breq    Poll_Matrix3                                 ;01
                ori     TOVTemp,$40                                  ;01
Poll_Matrix3:   sbi     PortA,6                                      ;01
                or      TOVTemp1,TOVTemp                             ;01

                cbi     PortA,5                                      ;01
                nop                                                  ;01
                in      TOVTemp,PINA                                 ;01
                com     TOVTemp                                      ;01
                andi    TOVTemp,$0F                                  ;01
                breq    Poll_Matrix4                                 ;01
                ori     TOVTemp,$20                                  ;01
Poll_Matrix4:   sbi     PortA,5                                      ;01
                or      TOVTemp1,TOVTemp                             ;01

                cbi     PortA,4                                      ;01
                nop                                                  ;01
                in      TOVTemp,PINA                                 ;01
                com     TOVTemp                                      ;01
                andi    TOVTemp,$0F                                  ;01
                breq    Poll_Matrix5                                 ;01
                ori     TOVTemp,$10                                  ;01
Poll_Matrix5:   sbi     PortA,4                                      ;01
                or      TOVTemp,TOVTemp1                             ;01
                pop     TOVTemp1                                     ;01
                ret                                                  ;01
                

;**************************************************
;*         4x8 Matrix mittels 74HC138             *
;* Pin 0..3 Input, 4..6 Output an 138, 7=LCD_SEL2 *
;* Rckgabewert = [Spalte,Zeile]                  *
;* mit Spalte=[1..8], Zeile=[1,2,4,8]             *

Poll_138:
		push	Temp		    ;                        ;01b
		in	TOVTemp,PortA	    ; Zustand von LCD_SEL2   ;01b
		bst	TOVTemp,7	    ; in T sichern           ;01b
		ldi	TOVTemp,$0F	    ; Pin0..4=High (Inputs)  ;01b
		mov	TOVTemp1,TOVTemp    ;                        ;01b
		bld	TOVTemp1,7	    ; und wieder ausgeben    ;01b
		clr	Temp		    ; Temp als counter       ;01b
Poll_138_scan:
		out	PortA,TOVTemp1	    ; Spalte ausgeben        ;01b
		nop			    ;                        ;01b
		in	TOVTemp,PinA	    ; Zeile lesen            ;01b
		com	TOVTemp		    ;                        ;01b
		andi	TOVTemp,$0F	    ; mask Pins 0..3         ;01b
		inc	Temp		    ;   Zhler erhhen       ;01b
		swap	Temp		    ;   Nibbles tauschen     ;01b
		cpi	TOVTemp,0	    ; Zeichen gefunden?      ;01b
		brne	Poll_138_done	    ; Dann aufhren          ;01b
		cpi	Temp,$80	    ; Alle Spalten gescannt? ;01b
		breq	Poll_138_nix	    ; ->Aufhren!            ;01b
		ori	Temp,$0F	    ; Lownibble setzten      ;01b
		mov	TOVTemp1,Temp	    ; Ausgabebyte vorbereiten;01b
		bld	TOVTemp1,7	    ; LCD_SEL2 nicht ndern! ;01b
		andi	Temp,$F0	    ; Lownibble zurcksetzten;01b
		swap	Temp		    ; Nibbles zurcktauschen ;01b
		rjmp	Poll_138_scan	    ; Nchste Spalte         ;01b
Poll_138_nix:
		clr	TOVTemp		    ; Zeile und              ;01b
		clr	Temp		    ; Spalte=0               ;01b
Poll_138_done:
		or	TOVTemp,Temp	    ; Spalte,Zeile verknpfen;01b
		pop	Temp		    ;                        ;01b
		pop	TOVTemp1	    ;                        ;01b
		ret                                                  ;01b


Dreh_Input:     in      TOVTemp,PIN_DREH
                swap    TOVTemp
                bst     TOVTemp,DREH0+4
                bld     TOVTemp,SDREH1
                bst     TOVTemp,DREH1+4
                bld     TOVTemp,SDREH0
                andi    TOVTemp,(1<<SDREH0) + (1<<SDREH1)
                ret



;*********************************************************************
;  Port-Initialisierung
;*********************************************************************
Port_Setting:
; Port D Setting
                ldi     Temp,(1<<DEMAND)+(1<<I2CC)+(1<<I2CD)   ; /CLR low ( MAS-Reset )
                out     PortD,Temp
                ldi     Temp,(1<<CLR)+(1<<I2CC)+(1<<KONTR); /CLR , I2CC , KONTR sind Ausgnge
                out     DDRD,Temp
                cbi     PortD,INT                ; INT loeschen

; Port C Setting
                ldi     Temp,$000                ; Pull-Up's aus
                out     PortC,Temp
                ldi     Temp,$000                ; Port C ist Eingang
                out     DDRC,Temp

; Port B Setting
                ldi     Temp,(1<<DREH0)+(1<<DREH1)                   +(1<<SCLK)
                out     PortB,Temp
                ldi     Temp,                      (1<<INT)+(1<<BUSY)+(1<<SCLK)+(1<<SDATA)+(1<<LCD_SEL)
                out     DDRB,Temp                ; Light und Busy sind Ausgang

; Port A Setting
                ldi     Temp,$0FF                ; Pull-Up's an
                out     PortA,Temp

                ldi     Temp,$000                ; alles Eingnge (Tasten/Drehknopf)
                lds     TOVTemp,Systemcfg                            ;01
                sbrs    TOVTemp,DisEnh           ; Displaytype : 40er
                ldi     Temp,$080                ; 4x40 Display      ;01
                sbrs    TOVTemp,TastEnh                              ;01
                ldi     Temp,$0F0                ; Tasten-Matrix/Display
                out     DDRA,Temp

                ldi     Temp,(1<<COM1A1)+(1<<COM1B1)+(1<<PWM11)
                out     TCCR1A,Temp
                ret                                                  ;01


